/*
 * COMPSCI 375 Assignment 1
 * Ass1Frame.java
 *
 * By NN NN
 * ID: 1234567
 * UPI: nnn001
 * Date: 19/3/2005
 */

import java.io.*;
import java.awt.image.*;
import javax.imageio.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Ass1Frame extends JFrame {

	private final int RED=0,GREEN=1,BLUE=2;
	private BufferedImage bi;
	private int[] pixels = null;
	private int[][][] pixels2D = null;
	private int[] redF=new int[256];   //For histogram
	private int[] greenF=new int[256];   //For histogram
	private int[] blueF=new int[256];   //For histogram
	private boolean frequenciesCalculated=false;
	double histogramSF=1;
	private int w,h;
	private ImageCanvas imageCanvas;
	private ZoomCanvas zoomCanvas;
	private JTextArea posTA,rTA,gTA,bTA,intTA,meanTA,varTA;

	private final int TOP_BORDER=80;
	private final int LEFT_BORDER=20;
	private final int INTER_CANVAS_BORDER=10;

	public Ass1Frame(String fileName) {

		bi = null;
		try{
			bi = ImageIO.read(new File(fileName));
		}
		catch(IOException e){
			System.out.println("Error loading the file");
			System.exit(0);
		}
		addWindowListener(new WindowAdapter() {
      		public void windowClosing(WindowEvent e) {
        		System.exit(0);
      		}
		});

		//setLayout(new BorderLayout());
		setLayout(null);
		setSize(1024,768);
		setBackground(Color.white);
		setTitle(fileName);
		setResizable(false);
		w = bi.getWidth(); h = bi.getHeight();
		pixels = new int[w*h];
		bi.getRGB(0,0,w,h,pixels,0,w);
		pixels2D = convertOneDimTwoDim(pixels,w,h);

		posTA=new JTextArea();
		//posTA.setLocation(LEFT_BORDER,TOP_BORDER/2);
		posTA.setBounds(LEFT_BORDER,TOP_BORDER/8*3,120,15);
		posTA.setEditable(false);
		add(posTA);

		rTA=new JTextArea();
		rTA.setBounds(LEFT_BORDER+120,TOP_BORDER/8*3,40,15);
		rTA.setEditable(false);
		add(rTA);

		gTA=new JTextArea();
		gTA.setBounds(LEFT_BORDER+160,TOP_BORDER/8*3,40,15);
		gTA.setEditable(false);
		add(gTA);

		bTA=new JTextArea();
		bTA.setBounds(LEFT_BORDER+200,TOP_BORDER/8*3,40,15);
		bTA.setEditable(false);
		add(bTA);

		intTA=new JTextArea();
		intTA.setBounds(LEFT_BORDER,TOP_BORDER+h+20,100,15);
		intTA.setEditable(false);
		add(intTA);

		meanTA=new JTextArea();
		meanTA.setBounds(LEFT_BORDER+100,TOP_BORDER+h+20,100,15);
		meanTA.setEditable(false);
		add(meanTA);

		varTA=new JTextArea();
		varTA.setBounds(LEFT_BORDER+200,TOP_BORDER+h+20,100,15);
		varTA.setEditable(false);
		add(varTA);

		imageCanvas = new ImageCanvas(this,bi,w,h,pixels2D);
		imageCanvas.setLocation(LEFT_BORDER,TOP_BORDER);
		add(imageCanvas);

		zoomCanvas = new ZoomCanvas();
		zoomCanvas.setLocation(LEFT_BORDER+w+INTER_CANVAS_BORDER,TOP_BORDER);
		add(zoomCanvas);

		getFrequencies();

		setVisible(true);




	}

	public void paint(Graphics g) {
		if (frequenciesCalculated){
			int xStart=Math.max(LEFT_BORDER+w+INTER_CANVAS_BORDER+120,LEFT_BORDER+300+10);
			drawHistograms(g,xStart,TOP_BORDER); //Draw the histograms below the image
		}
	}

	//Main method//
	public static void main(String[] args) {
		if (args.length>0){
			new Ass1Frame(args[0]);
		}

		else System.out.println("Please specify a bmp file to load");

	}

	private int[][][] convertOneDimTwoDim(int[] pixels,int w, int h){
		int[][][] pixels2D=new int[w][h][4];
		for (int x=0; x<w; x++){
			for (int y=0; y<h; y++){
				int value = pixels[y*w+x];
				pixels2D[x][y][RED]=(value >> 16) & 0xFF;
				pixels2D[x][y][GREEN]=(value >> 8) & 0xFF;
				pixels2D[x][y][BLUE]=value & 0xFF;
			}
		}
		return pixels2D;
	}

	public void updateZoomCanvas(int[][][] pixels){
		zoomCanvas.setPixels(pixels);
	}

	public void updateText(){
		posTA.setText("Location = ("+imageCanvas.getX()+","+imageCanvas.getY()+")");
		int[] RGB=zoomCanvas.getRGB();
		rTA.setText("R="+RGB[RED]);
		gTA.setText("G="+RGB[GREEN]);
		bTA.setText("B="+RGB[BLUE]);
		double intensity=zoomCanvas.getIntensity();
		intensity=((int)(intensity*100))/100.0;
		intTA.setText("Intensity="+intensity);
		double mean=zoomCanvas.getMean();
		mean=((int)(mean*100))/100.0;
		meanTA.setText("Mean="+mean);
		double variance=zoomCanvas.getVariance();
		variance=((int)(variance*100))/100.0;
		varTA.setText("Variance="+variance);
	}

	private void getFrequencies(){
		for (int x=0; x<w; x++){
			for (int y=0; y<h; y++){
				redF[pixels2D[x][y][RED]]++;
				greenF[pixels2D[x][y][GREEN]]++;
				blueF[pixels2D[x][y][BLUE]]++;
			}
		}

		int maxFrequency = 0;
		for (int i=0; i<256; i++){
			maxFrequency=Math.max(maxFrequency,redF[i]);
			maxFrequency=Math.max(maxFrequency,greenF[i]);
			maxFrequency=Math.max(maxFrequency,blueF[i]);
		}

		histogramSF=100.0/maxFrequency;
		frequenciesCalculated=true;
		repaint();
	}




	private void drawHistograms(Graphics g, int x, int y){
		drawHistogram(g,RED,x,y);
		drawHistogram(g,GREEN,x,y+120);
		drawHistogram(g,BLUE,x,y+240);
	}

	private void drawHistogram(Graphics g, int col,int x, int y){

		for (int intensity=0; intensity < 256; intensity++){
			if (col==RED){
				g.setColor(new Color(intensity,0,0));
			}
			else if (col==GREEN){
				g.setColor(new Color(0,intensity,0));
			}
			else{
				g.setColor(new Color(0,0,intensity));
			}
			int frequency=0;
			if (col==RED) frequency=(int)(redF[intensity]*histogramSF);
			else if (col==GREEN) frequency=(int)(greenF[intensity]*histogramSF);
			else frequency=(int)(blueF[intensity]*histogramSF);
			g.drawLine(x+intensity,y+100,x+intensity,y+100-frequency);
			g.drawLine(x+intensity,y+100,x+intensity,y+110);
		}
		g.setColor(Color.black);
		g.drawLine(x,y,x,y+100); //Vertical axis
		g.setColor(Color.white);
		g.drawLine(x,y+101,x+256,y+101); //Horizontal axis

	}


}