/*
 * COMPSCI 375 Assignment 1
 * ImageCanvas.java
 *
 * By NN NN
 * ID: 1234567
 * UPI: nnng001
 * Date: 19/3/2005
 */

import java.io.*;
import java.awt.image.*;
import javax.imageio.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ImageCanvas extends Canvas implements MouseMotionListener{

	private static final int RED=0,GREEN=1,BLUE=2;
	private static final int ZOOM_RADIUS=5;

	private Ass1Frame mainFrame; //Reference to main ViewerCanvas object
	private BufferedImage image; //Reference to image being displayed
	int w,h; //Width and height of image
	private int[][][] pixels; //Array storing RGB values of pixels
	private int mouseX=-1, mouseY=-1;
	private boolean boxOn=false;

	public ImageCanvas(Ass1Frame mainFrame, BufferedImage image, int w, int h, int[][][] pixels){
		this.mainFrame=mainFrame;
		this.image=image;
		this.w=w;
		this.h=h;
		this.pixels=pixels;

		setSize(w,h);
		addMouseMotionListener(this);
	}

	public void paint(Graphics g){
		g.drawImage(image, 0, 0, null);
		if (boxOn){
			//System.out.println("Drawing box");
			g.setColor(Color.red);
			g.drawRect(mouseX-ZOOM_RADIUS-1,mouseY-ZOOM_RADIUS-1,2*ZOOM_RADIUS+2,2*ZOOM_RADIUS+2);
		}
	}

	public void mouseMoved(MouseEvent e){
		//System.out.println("Mouse moved");
		int x=e.getX(), y=e.getY();
		if (0<=x && x<w && 0<=y && y<h){
			boxOn=true;
			mouseX=x;
			mouseY=y;
			//Generate array of zoomed pixels
			int[][][] zoomPixels= new int[2*ZOOM_RADIUS+1][2*ZOOM_RADIUS+1][3];
			for (int i=mouseX-ZOOM_RADIUS,iZ=0; i<=mouseX+ZOOM_RADIUS; i++,iZ++){
				for (int j=mouseY-ZOOM_RADIUS,jZ=0; j<=mouseY+ZOOM_RADIUS; j++,jZ++){
					if (0<=i && i<w && 0<=j && j<h){
						for (int c=0; c<3; c++){
							zoomPixels[iZ][jZ][c]=pixels[i][j][c];
						}
					}
					else{
						zoomPixels[iZ][jZ][RED]=zoomPixels[iZ][jZ][GREEN]=zoomPixels[iZ][jZ][BLUE]=0;
					}
				}
			}
			mainFrame.updateZoomCanvas(zoomPixels);
		}
		else{
			boxOn=false;
		}
		repaint();
		mainFrame.updateText();
	}

	public void mouseDragged(MouseEvent e){
		mouseMoved(e); //Dragging has same effect as moving mouse
	}

	public int getX(){
		return mouseX;
	}
	public int getY(){
		return mouseY;
	}
}

