/*
 * COMPSCI 375 Assignment 1
 * ZoomCanvas.java
 *
 * By NN NN
 * ID: 1234567
 * UPI: nnn001
 * Date: 19/3/2005
 */

import java.io.*;
import java.awt.image.*;
import javax.imageio.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ZoomCanvas extends Canvas{

	private static final int RED=0,GREEN=1,BLUE=2;
	private static final int ZOOM_RADIUS=5;
	private static final int ZOOM_PIXEL_SIZE=10;

	//private ViewerCanvas mainFrame; //Reference to main ViewerCanvas object
	int w,h; //Width and height of image
	private int[][][] pixels; //Array storing RGB values of pixels in zoom panel

	public ZoomCanvas(){

		setSize((ZOOM_RADIUS*2+1)*ZOOM_PIXEL_SIZE+2,(ZOOM_RADIUS*2+1)*ZOOM_PIXEL_SIZE+2);
		pixels=new int[2*ZOOM_RADIUS+1][2*ZOOM_RADIUS+1][3];
		//Initially set all pixels in zoom canvas to black
		for (int x=0; x<2*ZOOM_RADIUS+1; x++){
			for (int y=0; y<2*ZOOM_RADIUS+1; y++){
				for (int c=0; c<3; c++){
					pixels[x][y][c]=0;
				}
			}
		}
	}

	public void setPixels(int[][][] newPixels){
		pixels=newPixels;
		repaint();
	}

	public int[] getRGB(){
		int[] RGB = new int[3];
		RGB[RED]=pixels[ZOOM_RADIUS][ZOOM_RADIUS][RED];
		RGB[GREEN]=pixels[ZOOM_RADIUS][ZOOM_RADIUS][GREEN];
		RGB[BLUE]=pixels[ZOOM_RADIUS][ZOOM_RADIUS][BLUE];
		return RGB;
	}

	public double getIntensity(){
	//Returns intensity of centre pixel in window
		int r=pixels[ZOOM_RADIUS][ZOOM_RADIUS][RED];
		int g=pixels[ZOOM_RADIUS][ZOOM_RADIUS][GREEN];
		int b=pixels[ZOOM_RADIUS][ZOOM_RADIUS][BLUE];
		return (r+g+b)/3.0;
	}

	public double getMean(){
	//Returns mean intensity of window
		double mean=0;
		for (int x=0; x<pixels.length; x++){
			for (int y=0; y<pixels[0].length; y++){
				int r=pixels[x][y][RED];
				int g=pixels[x][y][GREEN];
				int b=pixels[x][y][BLUE];
				mean+=(r+g+b)/3.0;
			}
		}
		mean/=(pixels.length*pixels.length);
		return mean;
	}

	public double getVariance(){
	//Returns variance of intensity in window
		double variance=0;
		double mean=getMean();
		for (int x=0; x<pixels.length; x++){
			for (int y=0; y<pixels[0].length; y++){
				int r=pixels[x][y][RED];
				int g=pixels[x][y][GREEN];
				int b=pixels[x][y][BLUE];
				double diff=(r+g+b)/3.0-mean;
				variance+=diff*diff;
			}
		}
		variance/=(pixels.length*pixels.length);
		return variance;
	}


	public void paint(Graphics g){
		g.setColor(Color.red);
		g.drawRect(0,0,(ZOOM_RADIUS*2+1)*ZOOM_PIXEL_SIZE+1,(ZOOM_RADIUS*2+1)*ZOOM_PIXEL_SIZE+1);

		int startX=1, startY=1;
		for (int x=0; x<(ZOOM_RADIUS*2+1); x++){
			for (int y=0; y<(ZOOM_RADIUS*2+1); y++){
				g.setColor(new Color(pixels[x][y][RED],pixels[x][y][GREEN],pixels[x][y][BLUE]));
				g.fillRect(startX+x*ZOOM_PIXEL_SIZE,startY+y*ZOOM_PIXEL_SIZE,ZOOM_PIXEL_SIZE,ZOOM_PIXEL_SIZE);
			}
		}
		g.setColor(Color.red);
		g.drawRect(ZOOM_PIXEL_SIZE*ZOOM_RADIUS,ZOOM_PIXEL_SIZE*ZOOM_RADIUS,ZOOM_PIXEL_SIZE+1,ZOOM_PIXEL_SIZE+1);



	}

}

